/*
**	Copyright  1994 Novell, Inc.  All rights reserved.
**
**	Permission is granted to the recipient of this work ("you") to use,
**	reproduce and distribute Novell's original publication of the work free
**	of charge provided that you reproduce the work in its entirety and
**	include all Novell copyright notices as they originally appear.
**
**	Novell grants you permission to modify and distribute copies of this
**	work including any portion of this work (a "modified work") provided
**	that you include prominent notification of such modification along with
**	the date of modification on a modified work; distribute or publish a
**	modified work to third parties under the same conditions and granting
**	the same rights as are extended to you by Novell under this under
**	permission notice; and provided that you include a copy of Novell's
**	original publication of the work along with any copy of a modified
**	work.
**
**	NOVELL MAKES NO WARRANTY, REPRESENTATION OR PROMISE THAT THIS WORK OR A
**	MODIFIED WORK WILL SATISFY YOUR REQUIREMENTS OR THAT THIS WORK OR A
**	MODIFIED WORK IS WITHOUT DEFECT OR ERROR.  NOVELL DISCLAIMS AND
**	EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE OR
**	FITNESS FOR A PARTICULAR PURPOSE.
**
**	IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL NOVELL OR ANY OTHER
**	PARTY BE LIABLE FOR DAMAGES INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL,
**	CONSEQUENTIAL, INDIRECT OR PUNATIVE DAMAGES ARISING OUT OF THE USE OF
**	OR INABLITITY TO USE THE WORK OR A MODIFIED WORK.
**
**	DSVINT.H - October 1994
**
**	Declaration of the DSVInteger and DSVBoolean classes.
**
**	Author: John Buckle, Asia Pacific Support Centre, Novell Australia
**	==================================================================
**	9 Jan 1995           First release              John Buckle
*/

# ifndef dsVINT_H
# define dsVINT_H

# include "dsvalue.h"

/*
** Structure DSVBoolean
**
**	Used to hold SYN_BOOLEAN values.
*/

struct _DSCLASSDEC DSVBoolean : public DSValue
{
	BYTE		Data ;
	BYTE		Padding[3] ;

	NWDSCCODE	assign (NWSYNTAX_ID, void *) ;
	NWDSCCODE	compare(DSValue *) ;

			DSVBoolean()	 			{ Data = 0 ; }
			DSVBoolean(NWSYNTAX_ID s, void * v)	{ assign(s,v) ; }
		      ~	DSVBoolean()				{ release() ; }

	void *		data()					{ return & Data ; }
	DSValueType	type()					{ return DSCPP_BOOLEAN ; }
	NWPSTR		text(int = DSCPP_DEF_INDEX)		{ return (Data) ? "True" : "False" ; }
} ;

/*
** Structure DSVInteger
**
**	Used to hold SYN_INTEGER and SYN_COUNTER values.
*/

struct _DSCLASSDEC DSVInteger : public DSValue
{
	long		Data ;

	NWDSCCODE	assign (NWSYNTAX_ID, void *) ;
	NWDSCCODE	compare(DSValue *) ;

			DSVInteger()				{ Data = 0 ; }
			DSVInteger(NWSYNTAX_ID s, void * v)	{ assign(s,v) ; }
		      ~	DSVInteger()                 		{ release() ; }

	void *		data()					{ return & Data ; }
	DSValueType	type()					{ return DSCPP_INTEGER ; }
	NWPSTR		text(int = DSCPP_DEF_INDEX) ;
} ;

#endif dsVINT_H

